<!DOCTYPE html>
<html lang="<?php echo $USER_LANGUAGE;?>">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0, shrink-to-fit=no">
  <meta name="description" content="Cloud Desk 3">
  <meta name="keywords" content="Your premium Live Support/Chat application from JAKWEB">
  <meta name="author" content="Cloud Desk 3">
  <meta name="apple-mobile-web-app-capable" content="yes">
  <title><?php echo $SECTION_TITLE;?> - <?php echo JAK_TITLE;?></title>

  <link href="https://fonts.googleapis.com/css?family=Roboto:300,400,500,700|Roboto+Slab:400,700|Material+Icons" rel="stylesheet">
  <link rel="stylesheet" href="<?php echo BASE_URL;?>css/material.css?=<?php echo JAK_UPDATED;?>" type="text/css" media="screen">
  <?php if ($css_file_header) { ?>
    <link rel="stylesheet" href="<?php echo $css_file_header;?>" type="text/css">
  <?php } ?>
  
  <?php if ($jkl["rtlsupport"]) { ?>
  <!-- RTL Support -->
  <link rel="stylesheet" href="https://cdn.rtlcss.com/bootstrap/v4.5.3/css/bootstrap.min.css" integrity="sha384-P4uhUIGk/q1gaD/NdgkBIl3a6QywJjlsFJFk7SPRdruoGddvRVSwv5qFnvZ73cpz" crossorigin="anonymous">
  <!-- End RTL Support -->
  <?php } ?>
  
  <!-- Le fav and touch icons -->
  <link rel="shortcut icon" href="<?php echo BASE_URL_ORIG;?>img/ico/favicon.ico">
  <link rel="apple-touch-icon-precomposed" sizes="144x144" href="<?php echo BASE_URL_ORIG;?>img/ico/144.png">
  <link rel="apple-touch-icon-precomposed" sizes="114x114" href="<?php echo BASE_URL_ORIG;?>img/ico/114.png">
  <link rel="apple-touch-icon-precomposed" sizes="72x72" href="<?php echo BASE_URL_ORIG;?>img/ico/72.png">
  <link rel="apple-touch-icon-precomposed" href="<?php echo BASE_URL_ORIG;?>img/ico/57.png">

</head>
<body class="<?php echo (JAK_USERID ? ($jakuser->getVar("navsidebar") ? 'sidebar-mini' : '') : 'off-canvas-sidebar');?>">
  <?php if (JAK_USERID) { ?>
    <div class="wrapper">
      <div class="sidebar" data-color="<?php echo $jakuser->getVar("themecolour");?>" data-background-color="<?php echo $jakuser->getVar("menubg");?>" data-image="<?php echo BASE_URL;?>img/sidebar.jpg">

        <div class="logo">
          <a href="<?php echo BASE_URL_ADMIN;?>" class="simple-text logo-mini">
            <?php echo $short_title;?>
          </a>
          <a href="<?php echo BASE_URL_ADMIN;?>" class="simple-text logo-normal">
            <?php echo JAK_TITLE;?>
          </a>
        </div>
        <div class="sidebar-wrapper">
          <div class="user">
            <div class="photo">
              <img src="<?php echo BASE_URL_ORIG.basename(JAK_FILES_DIRECTORY).$jakuser->getVar("picture");?>">
            </div>
            <div class="user-info">
              <a href="<?php echo JAK_rewrite::jakParseurl('users','edit',JAK_USERID, (JAK_USERID != $opcacheid ? $opcacheid : ''));?>" class="username">
                <span>
                  <?php echo $jakuser->getVar("name");?>
                </span>
              </a>
            </div>
          </div>
          <?php include_once 'navbar.php';?>
        </div>
      </div>
      <div class="main-panel">
        <!-- Navbar -->
        <nav class="navbar navbar-expand-lg navbar-transparent navbar-absolute fixed-top " id="navigation-example">
          <div class="container-fluid">
            <div class="navbar-wrapper">
              <div class="navbar-minimize">
                <button id="minimizeSidebar" class="btn btn-just-icon btn-white btn-fab btn-round">
                  <i class="material-icons text_align-center visible-on-sidebar-regular">more_vert</i>
                  <i class="material-icons design_bullet-list-67 visible-on-sidebar-mini">view_list</i>
                </button>
              </div>
              <a class="navbar-brand" href="<?php echo ($page == '' ? BASE_URL_ADMIN : $_SESSION['LCRedirect']);?>"><?php echo $SECTION_TITLE;?></a>
            </div>
            <button class="navbar-toggler" type="button" data-toggle="collapse" aria-controls="navigation-index" aria-expanded="false" aria-label="Toggle navigation" data-target="#navigation-example">
              <span class="sr-only">Toggle navigation</span>
              <span class="navbar-toggler-icon icon-bar"></span>
              <span class="navbar-toggler-icon icon-bar"></span>
              <span class="navbar-toggler-icon icon-bar"></span>
            </button>
            <div class="collapse navbar-collapse justify-content-end">
              <form class="navbar-form" action="<?php echo JAK_rewrite::jakParseurl('search');?>" method="post">
                <div class="input-group no-border">
                  <input type="text" class="form-control" name="sitesearch" placeholder="<?php echo $jkl['s5'];?>">
                  <button type="submit" class="btn btn-white btn-round btn-just-icon">
                    <i class="material-icons">search</i>
                    <div class="ripple-container"></div>
                  </button>
                </div>
              </form>
              <ul class="navbar-nav">
                <li class="nav-item">
                  <a class="nav-link" href="<?php echo BASE_URL_ADMIN;?>">
                    <i class="material-icons">dashboard</i>
                    <p class="d-lg-none d-md-block">
                      <?php echo $jkl['m'];?>
                    </p>
                  </a>
                </li>
                <li class="nav-item dropdown" id="chatRequests" style="display: none">
                  <a class="nav-link" href="javascript:void(0)" id="navBarChat" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <i class="material-icons">chat</i>
                    <span class="notification" id="totalchats"></span>
                    <p class="d-lg-none d-md-block">
                      <?php echo $jkl['hd140'];?>
                    </p>
                  </a>
                  <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navBarChat" id="currentConv">
                  </div>
                </li>
                <li class="nav-item dropdown" id="ticketRequests" style="display: none">
                  <a class="nav-link" href="javascript:void(0)" id="navBarTickets" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <i class="material-icons">healing</i>
                    <span class="notification" id="totaltickets"></span>
                    <p class="d-lg-none d-md-block">
                      <?php echo $jkl['hd'];?>
                    </p>
                  </a>
                  <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navBarTickets" id="currentTickets">
                  </div>
                </li>
                <?php if ($jakuser->getVar("operatorlist") || $jakuser->getVar("operatorchat")) { ?>
                  <li class="nav-item dropdown" id="opRequests" style="display: none">
                    <a class="nav-link" href="javascript:void(0)" id="navBarOperators" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                      <i class="material-icons">supervisor_account</i>
                      <span class="notification" id="totalops"></span>
                      <p class="d-lg-none d-md-block">
                        <?php echo $jkl['g134'];?>
                      </p>
                    </a>
                    <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navBarOperators" id="operatorOnline">
                    </div>
                  </li>
                <?php } ?>
                <?php if ($jakosub['operatorchat'] && $jakuser->getVar("operatorchatpublic") == 1){;?>
                <li class="nav-item">
                  <a href="javascript:void(0)" class="nav-link" id="operator_chat" title="<?php echo $jkl["h9"];?>" onclick="if(navigator.userAgent.toLowerCase().indexOf('opera') != -1 && window.event.preventDefault) window.event.preventDefault();this.newWindow = window.open('<?php echo JAK_rewrite::jakParseurl('chat');?>', 'lsr', 'toolbar=0,scrollbars=1,location=0,status=1,menubar=0,width=800,height=520,resizable=1');this.newWindow.focus();this.newWindow.opener=window;return false;"><i class="material-icons">forum</i></a>
                </li>
                <?php } ?>
                <li class="nav-item dropdown">
                  <a class="nav-link dropdown-toggle" href="javascript:void(0)" id="navbarDropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <i class="material-icons">public</i>
                    <p><?php echo $jkl["i64"];?></p>
                  </a>
                  <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdownMenuLink">
                    <?php if (jak_get_access("support", $jakuser->getVar("permissions"), JAK_MAIN_OP)) { ?>
                      <a class="dropdown-item" href="<?php echo JAK_rewrite::jakParseurl('support', 'new');?>"><?php echo $jkl["hd166"];?></a>
                    <?php } if (jak_get_access("responses", $jakuser->getVar("permissions"), JAK_MAIN_OP)){?>
                      <a class="dropdown-item" href="<?php echo JAK_rewrite::jakParseurl('response');?>"><?php echo $jkl["m3"];?></a>
                    <?php } if (jak_get_access("widget", $jakuser->getVar("permissions"), JAK_MAIN_OP)){?>
                      <a class="dropdown-item" href="<?php echo JAK_rewrite::jakParseurl('widget');?>"><?php echo $jkl["m26"];?></a>
                    <?php } ?>
                    <a class="dropdown-item" href="<?php echo BASE_URL_ORIG;?>"><?php echo $jkl["i64"];?></a>
                  </div>
                </li>
                <li class="nav-item dropdown">
                  <a class="nav-link  dropdown-toggle" href="javascript:void(0)" id="navbarDropdownMenuProfile" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <i class="material-icons">person</i>
                    <p class="d-lg-none d-md-block">
                      <?php echo $jakuser->getVar("name");?>
                    </p>
                  </a>
                  <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdownMenuProfile">
                    <a class="dropdown-item" href="<?php echo JAK_rewrite::jakParseurl('users','edit',JAK_USERID, (JAK_USERID != $opcacheid ? $opcacheid : ''));?>"><?php echo $jkl['m11'];?></a>
                    <a class="dropdown-item<?php echo ($jakuser->getVar("sound") ? ' active' : '');?>" href="javascript:void(0)" id="sound_alert" onclick="toggleAlert()"><?php echo $jkl['g2'];?></a>
                    <a class="dropdown-item<?php echo ($jakuser->getVar("push_notifications") ? ' active' : '');?>" href="javascript:void(0)" id="push_alert" onclick="togglePush()"><?php echo $jkl["u16"];?></a>
                    <a class="dropdown-item<?php if ($page == "tickets") echo " active";?>" href="<?php echo JAK_rewrite::jakParseurl('tickets');?>"><?php echo $jkl["m36"];?></a>
                  </div>
                </li>
                <li class="nav-item dropdown">
                <a class="nav-link dropdown-toggle" href="javascript:void(0)" id="navbarDropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" title="<?php echo $jkl['hd167'];?>">
                  <i id="operator-status-colour" class="material-icons<?php if ($jakuser->getVar("available") == 0) { echo ' text-danger'; } elseif ($jakuser->getVar("available") == 2) { echo ' text-warning'; } else { echo ' text-success';}?>">support_agent</i>
                </a>
                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdownMenuLink">
                  <a class="dropdown-item text-success" href="javascript:void(0)" onclick="toggleAvailable(1,<?php echo $JAK_UONLINE;?>)"><i class="material-icons">support_agent</i> <?php echo $jkl["g"];?></a>
                  <a class="dropdown-item text-warning" href="javascript:void(0)" onclick="toggleAvailable(2,<?php echo $JAK_UONLINE;?>)"><i class="material-icons">support_agent</i> <?php echo $jkl["g202"];?></a>
                  <a class="dropdown-item text-danger" href="javascript:void(0)" onclick="toggleAvailable(0,0)"><i class="material-icons">support_agent</i> <?php echo $jkl["g1"];?></a>
                </div>
              </li>
              <?php if (JAK_MAIN_OP) { ?>
                <li class="nav-item">
                  <a class="nav-link" href="<?php echo JAK_rewrite::jakParseurl('extend');?>">
                    <i class="material-icons">local_mall</i>
                    <p class="d-lg-none d-md-block">
                      <?php echo $jkl['i63'];?>
                    </p>
                  </a>
                </li>
                <?php } ?>
                <li class="nav-item">
                  <a class="nav-link" href="<?php echo JAK_rewrite::jakParseurl('lock');?>">
                    <i class="material-icons">lock</i>
                    <p><?php echo $jkl["l21"];?></p>
                  </a>
                </li>
                <li class="nav-item">
                  <a class="nav-link btn-confirm" href="<?php echo JAK_rewrite::jakParseurl('logout');?>" data-title="<?php echo addslashes($jkl["l18"]);?>" data-text="<?php echo addslashes($jkl["l20"]);?>" data-type="warning" data-okbtn="<?php echo addslashes($jkl["g279"]);?>" data-cbtn="<?php echo addslashes($jkl["g280"]);?>">
                    <i class="material-icons">power_settings_new</i>
                    <p><?php echo $jkl["l18"];?></p>
                  </a>
                </li>
              </ul>
            </div>
          </div>
        </nav>

        <div class="content">
          <div class="container-fluid">

            <!-- Show the user that the connection to the server has been interrupted -->
            <div class="alert alert-rose" id="connection-error" style="display:none"><i class="fa fa-exclamation-triangle"></i> <?php echo $jkl["g330"];?></div>

            <div id="transfer"></div>

            <?php } ?>
