<!DOCTYPE html>
<html lang="<?php echo $JAK_CMS_PAGE["lang"];?>">
<head>
  <meta charset="utf-8">
  <meta content="width=device-width, shrink-to-fit=no" name="viewport">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <meta name="keywords" content="<?php echo (isset($JAK_CMS_PAGE["meta_keywords"]) ? trim($JAK_CMS_PAGE["meta_keywords"]) : '');?>">
  <meta name="description" content="<?php echo (isset($JAK_CMS_PAGE["meta_description"]) ? trim($JAK_CMS_PAGE["meta_description"]) : '');?>">
  <meta name="author" content="<?php echo JAK_TITLE;?>">
  <?php if ($page == '404') { ?>
  <meta name="robots" content="noindex, follow">
  <?php } else { ?>
  <meta name="robots" content="index, follow">
  <?php } if ($page == "success" or $page == "logout") { ?>
  <meta http-equiv="refresh" content="1;URL=<?php echo $_SERVER['HTTP_REFERER'];?>">
  <?php } ?>
  <title><?php echo (isset($JAK_CMS_PAGE["title"]) && !empty($JAK_CMS_PAGE["title"]) ? $JAK_CMS_PAGE["title"].' - ' : '').JAK_TITLE;?></title>
  <?php if (isset($JAK_CMS_PAGE["previmg"]) && !empty($JAK_CMS_PAGE["previmg"])) { ?>
  <meta property="og:title" content="<?php echo (isset($JAK_CMS_PAGE["title"]) && !empty($JAK_CMS_PAGE["title"]) ? $JAK_CMS_PAGE["title"] : JAK_TITLE);?>">
  <meta property="og:type" content="website">
  <meta property="og:url" content="<?php echo JAK_rewrite::jakParseurl($page, $page1, $page2, $page3, $page4, $page5, $page6);?>">
  <meta property="og:image" content="<?php echo (JAK_USE_APACHE ? substr(BASE_URL, 0, -1) : BASE_URL).str_replace(JAK_EDITOR_PATH_BASE, "", $JAK_CMS_PAGE["previmg"]);?>">
  <meta property="og:description" content="<?php echo trim($JAK_CMS_PAGE["meta_description"]);?>">
  <?php if (!empty(JAK_FACEBOOK_APP_ID)) { ?><meta property="fb:app_id" content="<?php echo JAK_FACEBOOK_APP_ID;?>"><?php } ?>
  <?php } ?>

  <link rel="canonical" href="<?php echo JAK_rewrite::jakParseurl($page, $page1, $page2, $page3, $page4, $page5, $page6);?>">
  <link rel="alternate" hreflang="<?php echo (isset($JAK_CMS_PAGE["lang"]) ? $JAK_CMS_PAGE["lang"] : '');?>" href="<?php echo BASE_URL;?>">

  <?php if ($jkl["rtlsupport"]) { ?>
  <!-- RTL Support -->
  <link rel="stylesheet" href="https://cdn.rtlcss.com/bootstrap/v4.5.3/css/bootstrap.min.css" integrity="sha384-P4uhUIGk/q1gaD/NdgkBIl3a6QywJjlsFJFk7SPRdruoGddvRVSwv5qFnvZ73cpz" crossorigin="anonymous">
  <link href="<?php echo BASE_URL;?>template/<?php echo JAK_FRONT_TEMPLATE;?>/css/style-rtl.css" rel="stylesheet">
  <!-- End RTL Support -->
  <?php } ?>

  <link rel="stylesheet" href="<?php echo BASE_URL;?>css/bootstrap.css" media="screen">
  <link rel="stylesheet" href="<?php echo BASE_URL;?>css/fontawesome.css" media="screen">
  <link rel="stylesheet" href="<?php echo BASE_URL;?>css/dropzone.css">

  <!-- Fonts and icons -->
  <link href="https://fonts.googleapis.com/css?family=Montserrat:400,700,200" rel="stylesheet">
  <link rel="stylesheet" href="<?php echo BASE_URL;?>css/fontawesome.css" media="screen">
  <!-- CSS Files -->
  <link href="<?php echo BASE_URL;?>template/<?php echo JAK_FRONT_TEMPLATE;?>/css/style.css" rel="stylesheet">
  <link href="<?php echo BASE_URL;?>template/<?php echo JAK_FRONT_TEMPLATE;?>/css/prism.css" rel="stylesheet">

  <?php if ($jkl["rtlsupport"]) { ?>
    <!-- RTL Support -->
    <link rel="stylesheet" href="<?php echo BASE_URL;?>css/style-rtl.css?=<?php echo JAK_UPDATED;?>" type="text/css" media="screen">
    <!-- End RTL Support -->
    <?php } ?>

    <?php if (JAK_CLIENTID && $jakclient->getVar("frontendadmin") == 1) { ?>
  <link rel="stylesheet" href="<?php echo BASE_URL;?>template/<?php echo JAK_FRONT_TEMPLATE;?>/editor/summernote-bs4.min.css" type="text/css" media="screen">
  <?php } ?>

</head>
<body>

<!--[if lt IE 9]>
<div class="alert alert-danger">We have dropped Support for IE9 and below. Please update your browser or use the latest Firefox, Chrome or Safari.</div>
<![endif]-->

<?php if (JAK_HOLIDAY_MODE == 1 && JAK_USERID) { ?>
<div class="alert-offline"><?php echo $tl["title"]["t10"];?></div>
<?php } ?>

<?php if (!isset($_SESSION["webembed"])) {

  include_once APP_PATH.'template/business/tplblocks/navbar.php';

  if ($page == "404") {
    include_once APP_PATH.'template/business/tplblocks/header-404.php';
  } elseif ($page == JAK_SUPPORT_URL && $page1 == "t") {
      include_once APP_PATH.'template/business/tplblocks/header-ticket.php';
    } elseif ($page == JAK_FAQ_URL && $page1 == "a") {
      include_once APP_PATH.'template/business/tplblocks/header-faq-article.php';
    } elseif ($page == JAK_BLOG_URL && $page1 == "a") {
      include_once APP_PATH.'template/business/tplblocks/header-blog-article.php';
    } elseif ($page == JAK_CLIENT_URL && $page1 == "rt") {
      include_once APP_PATH.'template/business/tplblocks/header-rating-ticket.php';
  } elseif (isset($JAK_CMS_PAGE["header_tpl"]) && !empty($JAK_CMS_PAGE["header_tpl"])) {
      include_once APP_PATH.'template/business/tplblocks/header_tpl/'.$JAK_CMS_PAGE["header_tpl"];
    } else {
      include_once APP_PATH.'template/business/tplblocks/header_tpl/header-standard.php';
    }

} ?>
